# Python bytecode 2.7 (decompiled from Python 2.7)
# Embedded file name: e:\jenkins\workspace\client_SERENITY\branches\release\SERENITY\carbon\client\script\graphics\boxLightClient.py
import cef
import graphics
import trinity
import util
import carbon.client.script.graphics.graphicWrappers.loadAndWrap as graphicWrappers

class BoxLightClientComponent:
    __guid__ = 'component.BoxLightClientComponent'


class BoxLightClient(graphics.LightClient):
    __guid__ = 'svc.boxLightClient'
    __componentTypes__ = [cef.BoxLightComponentView.GetComponentCodeName()]

    def CreateComponent(self, name, state):
        component = BoxLightClientComponent()
        renderObject = trinity.Tr2InteriorBoxLight()
        component.renderObject = renderObject
        graphicWrappers.Wrap(renderObject)
        component.originalPrimaryLighting = bool(state['primaryLighting'])
        component.performanceLevel = state['performanceLevel']
        renderObject.SetColor((state['red'], state['green'], state['blue']))
        renderObject.SetScaling((state['scaleX'], state['scaleY'], state['scaleZ']))
        renderObject.SetFalloff(state['falloff'])
        renderObject.shadowImportance = state['shadowImportance']
        renderObject.primaryLighting = bool(state['primaryLighting'])
        renderObject.affectTransparentObjects = bool(state['affectTransparentObjects'])
        renderObject.shadowResolution = int(state['shadowResolution'])
        renderObject.shadowCasterTypes = int(state['shadowCasterTypes'])
        renderObject.projectedTexturePath = state['projectedTexturePath'].encode()
        renderObject.importanceScale = state['importanceScale']
        renderObject.importanceBias = state['importanceBias']
        renderObject.enableShadowLOD = bool(state['enableShadowLOD'])
        renderObject.specularIntensity = float(state.get('specularIntensity', '1'))
        renderObject.useKelvinColor = bool(state['useKelvinColor'])
        if renderObject.useKelvinColor:
            renderObject.kelvinColor.temperature = state['temperature']
            renderObject.kelvinColor.tint = state['tint']
            renderObject.kelvinColor.whiteBalance = int(state['whiteBalance'])
        component.originalShadowCasterTypes = renderObject.shadowCasterTypes
        if '_spawnID' in state:
            component.renderObject.name = self.GetName(state['_spawnID'])
        return component

    def ApplyShadowCasterType(self, entity):
        component = entity.GetComponent('boxLight')
        if component is None:
            return
        else:
            dynamicShadows = sm.GetService('device').GetAppFeatureState('Interior.dynamicShadows', True)
            shadowCasters = trinity.Tr2InteriorShadowCasterTypes
            if dynamicShadows:
                component.renderObject.shadowCasterTypes = component.originalShadowCasterTypes
            elif component.originalShadowCasterTypes == shadowCasters.DynamicOnly:
                component.renderObject.shadowCasterTypes = shadowCasters.None
            elif component.originalShadowCasterTypes == shadowCasters.All:
                component.renderObject.shadowCasterTypes = shadowCasters.StaticsOnly
            return

    def ApplyPerformanceLevelLightDisable(self, entity):
        component = entity.GetComponent('boxLight')
        if component is None:
            return
        else:
            appPerformanceLevel = sm.GetService('device').GetAppFeatureState('Interior.lightPerformanceLevel', 2)
            if component.performanceLevel > appPerformanceLevel:
                component.renderObject.primaryLighting = False
            else:
                component.renderObject.primaryLighting = component.originalPrimaryLighting
            return