# Python bytecode 2.7 (decompiled from Python 2.7)
# Embedded file name: e:\jenkins\workspace\client_SERENITY\branches\release\SERENITY\eve\client\script\environment\spaceObject\stargate.py
import uthread
import blue
import eve.common.lib.appConst as const
from eve.client.script.environment.spaceObject.spaceObject import SpaceObject

class Stargate(SpaceObject):

    def __init__(self):
        SpaceObject.__init__(self)
        self.lastActivationTime = 0
        self.activeStateDuration = 15 * const.SEC
        self.isDeactivationThreadRunning = False
        self.isActive = False
        self.deactivationCurve = None
        self.activationCurve = None
        self.lightningTransform = None
        self.arrivalCurve = None
        self.departureCurve = None
        return

    def _SetupStargateEffects(self, model):
        gateStateChild = None
        for child in model.effectChildren:
            for each in child.objects:
                if each.name == 'GATE_STATE':
                    gateStateChild = each
                elif each.name == 'FX_DEPARTURE':
                    self.departureCurve = each.curveSets[0]
                elif each.name == 'FX_ARRIVAL':
                    self.arrivalCurve = each.curveSets[0]
                else:
                    self.lightningTransform = child
                    break

        if gateStateChild is None:
            return
        else:
            for each in gateStateChild.curveSets:
                if each.name == 'ACTIVATE_STATE':
                    self.activationCurve = each
                elif each.name == 'DEACTIVATE_STATE':
                    self.deactivationCurve = each

            return

    def LoadModel(self, fileName=None, loadedModel=None):
        filename = self.typeData.get('graphicFile')
        model = self._LoadModelResource(filename)
        if model is not None:
            self._SetupStargateEffects(model)
        SpaceObject.LoadModel(self, loadedModel=model)
        self.SetStaticRotation()
        return

    def Assemble(self):
        if hasattr(self.model, 'ChainAnimationEx'):
            self.model.ChainAnimationEx('NormalLoop', 0, 0, 1.0)
        self.SetupAmbientAudio(u'worldobject_jumpgate_atmo_play')

    def _ActivationCooldown(self):

        def _deactivateThread():
            timeNow = blue.os.GetSimTime()
            while not self.released and timeNow < self.lastActivationTime + self.activeStateDuration:
                blue.synchro.SleepUntilSim(self.lastActivationTime + self.activeStateDuration)
                timeNow = blue.os.GetSimTime()

            self.isDeactivationThreadRunning = False
            self.isActive = False
            if not self.released:
                if self.lightningTransform is not None:
                    self.lightningTransform.display = False
                if self.deactivationCurve is not None:
                    self.deactivationCurve.Play()
                    self.deactivationCurve.StopAfter(self.deactivationCurve.GetMaxCurveDuration())
            return

        if not self.isDeactivationThreadRunning:
            self.isDeactivationThreadRunning = True
            uthread.new(_deactivateThread)

    def Activate(self):
        self.lastActivationTime = blue.os.GetSimTime()
        if self.activationCurve is not None and not self.isActive:
            self.activationCurve.Play()
            self.activationCurve.StopAfter(self.activationCurve.GetMaxCurveDuration())
        if self.lightningTransform is not None:
            self.lightningTransform.display = True
        self.isActive = True
        self._ActivationCooldown()
        return

    def JumpDeparture(self):
        if self.departureCurve is not None:
            self.departureCurve.Play()
            self.departureCurve.StopAfter(self.departureCurve.GetMaxCurveDuration())
        return

    def JumpArrival(self):
        if self.arrivalCurve is not None:
            self.arrivalCurve.Play()
            self.arrivalCurve.StopAfter(self.arrivalCurve.GetMaxCurveDuration())
        return