# Python bytecode 2.7 (decompiled from Python 2.7)
# Embedded file name: e:\jenkins\workspace\client_SERENITY\branches\release\SERENITY\eve\client\script\ui\inflight\bracketsAndTargets\blinkingSpriteOnSharedCurve.py
import uiprimitives
import uicls
import trinity

class BlinkingSpriteOnSharedCurve(uiprimitives.Sprite):
    __guid__ = 'uicls.BlinkingSpriteOnSharedCurve'

    def ApplyAttributes(self, attributes):
        uiprimitives.Sprite.ApplyAttributes(self, attributes)
        self.blinkBinding = None
        curveSetName = attributes.curveSetName
        self.curveSetName = curveSetName
        fromCurveValue = attributes.get('fromCurveValue', 0.3)
        toCurveValue = attributes.get('toCurveValue', 0.6)
        duration = attributes.get('duration', 0.5)
        self.SetupSharedBlinkingCurve(curveSetName, fromCurveValue, toCurveValue, duration)
        return

    def SetupSharedBlinkingCurve(self, cuverSetName, fromCurveValue, toCurveValue, duration, *args):
        curveSet = getattr(uicore, cuverSetName, None)
        if curveSet:
            curve = curveSet.curves[0]
        else:
            curveSet = trinity.TriCurveSet()
            setattr(uicore, cuverSetName, curveSet)
            setattr(curveSet, 'name', cuverSetName)
            trinity.device.curveSets.append(curveSet)
            curveSet.Play()
            curve = trinity.Tr2ScalarCurve()
            curve.name = 'blinking_curve'
            curve.length = duration
            curve.startValue = fromCurveValue
            curve.endValue = fromCurveValue
            curve.AddKey(duration / 2.0, toCurveValue)
            curve.cycle = True
            curve.interpolation = trinity.TR2CURVE_LINEAR
            curveSet.curves.append(curve)
        if getattr(self, 'blinkBinding', None) is not None:
            curveSet.bindings.remove(self.blinkBinding)
        self.blinkBinding = trinity.CreatePythonBinding(curveSet, curve, 'currentValue', self, 'opacity')
        return

    def Close(self):
        if getattr(self, 'blinkBinding', None) is not None:
            curveSet = getattr(uicore, self.curveSetName, None)
            if curveSet:
                curveSet.bindings.remove(self.blinkBinding)
            self.blinkBinding = None
        uiprimitives.Sprite.Close(self)
        return