# Python bytecode 2.7 (decompiled from Python 2.7)
# Embedded file name: e:\jenkins\workspace\client_SERENITY\branches\release\SERENITY\packages\fsd\simpleSearch\dataExtractor.py


def ExtractFromDict(obj, schema, fieldValueMap):
    if CheckSchemaNode(schema, fieldValueMap):
        return {'found': True,
         'object': obj}
    foundSomeData = False
    extractedObject = {}
    for each in obj:
        data = WalkSchema(obj[each], schema.get('valueTypes'), fieldValueMap)
        if data['found']:
            foundSomeData = True
            extractedObject[each] = data['object']

    return {'found': foundSomeData,
     'object': extractedObject}


def ExtractFromList(obj, schema, fieldValueMap):
    if CheckSchemaNode(schema, fieldValueMap):
        return {'found': True,
         'object': obj}
    foundSomeData = False
    extractedObject = []
    for each in obj:
        data = WalkSchema(each, schema.get('itemTypes'), fieldValueMap)
        if data['found']:
            foundSomeData = True
            extractedObject.append(data['object'])

    return {'found': foundSomeData,
     'object': extractedObject}


def ExtractFromObject(obj, schema, fieldValueMap):
    if CheckSchemaNode(schema, fieldValueMap):
        return {'found': True,
         'object': obj}
    foundSomeData = False
    extractedObject = {}
    for each in obj:
        data = WalkSchema(obj[each], schema.get('attributes')[each], fieldValueMap)
        if data['found']:
            foundSomeData = True
            extractedObject[each] = data['object']

    return {'found': foundSomeData,
     'object': extractedObject}


def ExtractFromLeafNode(obj, schema, fieldValueMap):
    if CheckSchemaNode(schema, fieldValueMap):
        return {'found': True,
         'object': obj}
    else:
        return {'found': False,
         'object': None}


def CheckSchemaNode(schema, fieldValueMap):
    for eachField in fieldValueMap:
        if schema.get(eachField, None) == fieldValueMap[eachField]:
            return True

    return False


builtInExtractionFunctions = {'dict': ExtractFromDict,
 'list': ExtractFromList,
 'object': ExtractFromObject}

def WalkSchema(obj, schemaNode, fieldValueMap):
    attributeType = schemaNode['type']
    if attributeType is None:
        return {'found': False,
         'object': None}
    else:
        if attributeType in builtInExtractionFunctions:
            newData = builtInExtractionFunctions[attributeType](obj, schemaNode, fieldValueMap)
        else:
            newData = ExtractFromLeafNode(obj, schemaNode, fieldValueMap)
        return newData


def ExtractData(obj, schema, fieldValueMap):
    newData = WalkSchema(obj, schema, fieldValueMap)
    if 'object' in newData:
        return newData['object']
    else:
        return None