# Python bytecode 2.7 (decompiled from Python 2.7)
# Embedded file name: e:\jenkins\workspace\client_SERENITY\branches\release\SERENITY\packages\projectdiscovery\client\projects\subcellular\info.py
import localization
INFO = {'projectId': 17,
 'name': 'Human Protein Atlas - Subcell Atlas - Finding reference patterns in sample image - Test project',
 'resultSchema': {'type': 'array',
                  'items': {'type': 'integer',
                            'enum': [101,
                                     102,
                                     111,
                                     112,
                                     113,
                                     121,
                                     122,
                                     123,
                                     131,
                                     201,
                                     202,
                                     203,
                                     211,
                                     212,
                                     213,
                                     214,
                                     215,
                                     221,
                                     222,
                                     231,
                                     232,
                                     233,
                                     301,
                                     302,
                                     303,
                                     901,
                                     902]},
                  'minItems': 1,
                  'maxItems': 5,
                  'uniqueItems': True},
 'resultExamples': [[10, 15, 25], [1], []],
 'assetsSchema': {'type': 'object',
                  'properties': {'urls': {'type': 'object',
                                          'properties': {'channelYellow': {'description': 'The URL of the image to be analysed (channel: yellow)',
                                                                           'type': 'string'},
                                                         'channelRed': {'description': 'The URL of the image to be analysed (channel: red)',
                                                                        'type': 'string'},
                                                         'channelGreen': {'description': 'The URL of the image to be analysed (channel: green)',
                                                                          'type': 'string'},
                                                         'channelBlue': {'description': 'The URL of the image to be analysed (channel: blue)',
                                                                         'type': 'string'},
                                                         'channelRedGreen': {'description': 'The URL of the image to be analysed (channel: red+green)',
                                                                             'type': 'string'},
                                                         'channelBlueRedGreen': {'description': 'The URL of the image to be analysed (channel: blue+red+green)',
                                                                                 'type': 'string'}}}}},
 'info': {'baseUrl': 'http://d31li3s7awgent.cloudfront.net/',
          'classes': [{'id': 1,
                       'parentId': None,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Nucleus/NucleusHeader'),
                       'description': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Nucleus/NucleusDescription')},
                      {'id': 10,
                       'parentId': 1,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Nucleus/NucleusHeader'),
                       'description': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Nucleus/NucleusDescription')},
                      {'id': 101,
                       'parentId': 10,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Nucleus/NucleusHeader'),
                       'description': 'The nucleus takes up a big part of the cell volume, and looks like a big, round ball. The nucleus contains the DNA, which encodes genetic information.',
                       'descriptionIdentification': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Nucleus/NucleusDescriptionIdentification'),
                       'descriptionScientific': 'The spherical nucleus takes up a big part of the cell volume. It contains the DNA, which encodes genetic information. The nucleus also contains all the proteins needed for maintaining and repairing the DNA structure as well as regulating its expression.',
                       'url': '101_hpa_subcell_task1_ref_HPA047549_nucleus.png',
                       'excludes': [102]},
                      {'id': 102,
                       'parentId': 10,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Nucleus/NucleoplasmHeader'),
                       'description': 'The nucleoplasm encompasses everything in the nucleus except the nucleoli.',
                       'descriptionIdentification': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Nucleus/NucleoplasmDescriptionIdentification'),
                       'descriptionScientific': 'The spherical nucleus takes up a big part of the cell volume. It contains the DNA, which encodes genetic information. The nucleus also contains all the proteins needed for maintaining and repairing the DNA structure as well as regulating its expression.',
                       'url': '102_hpa_subcell_task1_ref_HPA029693_nucleoplasm.png',
                       'excludes': [101, 12]},
                      {'id': 11,
                       'parentId': 1,
                       'name': 'Nuclear bodies and speckles',
                       'description': 'Nuclear pattern where not all of the nucleus is stained but only small structures within it.'},
                      {'id': 111,
                       'parentId': 11,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Nucleus/NuclearBodiesFewHeader'),
                       'description': 'Nuclear bodies are uneven structures found in the nucleus. It is a collective term for structures with different (often unknown) functions but similar staining pattern.',
                       'descriptionIdentification': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Nucleus/NuclearBodiesFewDescriptionIdentification'),
                       'descriptionScientific': 'Nuclear bodies is a collective term for structures with different functions but similar staining pattern found in the nucleus. They are smaller and their shape is more spherical compared to nuclear speckles. Distinct spotty staining patterns might be structures that help organizing the DNA, repairs DNA or pre-processing RNA.',
                       'url': '111_hpa_subcell_task1_ref_HPA036081_nuclear_bodies_few.png',
                       'excludes': [112]},
                      {'id': 112,
                       'parentId': 11,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Nucleus/NuclearBodiesManyHeader'),
                       'description': 'Nuclear bodies are uneven structures found in the nucleus. It is a collective term for structures with different (often unknown) functions but similar staining pattern.',
                       'descriptionIdentification': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Nucleus/NuclearBodiesManyDescriptionIdentification'),
                       'descriptionScientific': 'Nuclear bodies is a collective term for structures with different functions but similar staining pattern found in the nucleus. They are smaller and their shape is more spherical compared to nuclear speckles. Distinct spotty staining patterns might be structures that help organizing the DNA, repairs DNA or pre-processing RNA.',
                       'url': '112_hpa_subcell_task1_ref_CAB010194_nuclear_bodies_many.png',
                       'excludes': [111]},
                      {'id': 113,
                       'parentId': 11,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Nucleus/NuclearSpecklesHeader'),
                       'description': "A common pattern is a 'speckled' nuclear staining (like leopard speckles). They are distributed evenly throughout the nucleus (usually around 25-50 per cell). Speckles are also organizing the DNA.",
                       'descriptionIdentification': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Nucleus/NuclearSpecklesDescriptionIdentification'),
                       'descriptionScientific': 'A common pattern is a speckled nuclear staining (like leopard speckles). Speckles consist of smaller subunits that are involved in organizing the DNA and its expression.',
                       'url': '113_hpa_subcell_task1_ref_HPA002031_nuclear_speckles.png',
                       'excludes': []},
                      {'id': 12,
                       'parentId': 1,
                       'name': 'Nucleoli',
                       'description': 'Nucleoli are usually stained as small, somewhat elongated circles in the nucleus. However, their staining pattern can vary from the nucleolus being completely stained, to only a small part of it, sometimes in a spotty pattern. It is common that proteins are localized to both the nucleus and the nucleoli, with different staining intensity, as well as only the nucleoli. The nucleoli take part in several different processes in the cell, and produce part of the endoplasmic reticulum.'},
                      {'id': 121,
                       'parentId': 12,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Nucleus/NucleoliHeader'),
                       'description': 'Nucleoli are usually stained as small, somewhat elongated circles in the nucleus. However, their staining pattern can vary from the nucleolus being completely stained, to only a small part of it, sometimes in a spotty pattern. It is common that proteins are localized to both the nucleus and the nucleoli, with different staining intensity, as well as only the nucleoli. The nucleoli take part in several different processes in the cell, and produce part of the endoplasmic reticulum.',
                       'descriptionIdentification': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Nucleus/NucleoliDescriptionIdentification'),
                       'descriptionScientific': 'The staining pattern of nucleoli can vary from the nucleolus being completely stained, to only a small part of it, sometimes in a spotty pattern. It is common that proteins are localized to both the nucleus and the nucleoli, with different staining intensity, as well as only the nucleoli. The nucleoli take part in several different processes in the cell, and produce ribosomes, the protein synthezisers of the cell.',
                       'url': '121_hpa_subcell_task1_ref_HPA037389_nucleoli.png',
                       'excludes': [102]},
                      {'id': 122,
                       'parentId': 12,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Nucleus/NucleoliRimHeader'),
                       'description': 'The edge of the nucleoli is stained stronger than the rest of the nucleoli.',
                       'descriptionIdentification': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Nucleus/NucleoliRimDescriptionIdentification'),
                       'descriptionScientific': 'The staining pattern of nucleoli can vary from the nucleolus being completely stained, to only a small part of it, sometimes in a spotty pattern. It is common that proteins are localized to both the nucleus and the nucleoli, with different staining intensity, as well as only the nucleoli. The nucleoli take part in several different processes in the cell, and produce ribosomes, the protein synthezisers of the cell.',
                       'url': '122_hpa_subcell_task1_ref_HPA026512_nucleoli_rim.png',
                       'excludes': [102]},
                      {'id': 123,
                       'parentId': 12,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Nucleus/NucleoliFibrillarCenterHeader'),
                       'description': 'Clusters of small spots in the nucleoli.',
                       'descriptionIdentification': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Nucleus/NucleoliFibrillarCenterDescriptionIdentification'),
                       'descriptionScientific': 'The staining pattern of nucleoli can vary from the nucleolus being completely stained, to only a small part of it, sometimes in a spotty pattern. It is common that proteins are localized to both the nucleus and the nucleoli, with different staining intensity, as well as only the nucleoli. The nucleoli take part in several different processes in the cell, and produce ribosomes, the protein synthezisers of the cell.',
                       'url': '123_hpa_subcell_task1_ref_HPA006385_nucleoli_fibrillar_center.png',
                       'excludes': [102]},
                      {'id': 13,
                       'parentId': 1,
                       'name': 'Nuclear membrane',
                       'description': 'The nuclear membrane is easy to recognize, the staining forming a thin circle around the nucleus. It is sometimes also possible to see the the many folds of the nuclear membrane. Its purpose is to keep the nucleus and cytoplasm separated, so the DNA in the nucleus stays in one place.'},
                      {'id': 131,
                       'parentId': 13,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Nucleus/NuclearMembraneHeader'),
                       'description': 'The nuclear membrane is easy to recognize, the staining forming a thin circle around the nucleus. It is sometimes also possible to see the the many folds of the nuclear membrane. Its purpose is to keep the nucleus and cytoplasm separated, so the DNA in the nucleus stays in one place.',
                       'descriptionIdentification': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Nucleus/NuclearMembraneDescriptionIdentification'),
                       'descriptionScientific': 'The purpose of the nuclear membrane is to keep the nucleus and cytoplasm separated, keeping the DNA contained in the nucleus. It also regulates the transport of proteins and other molecules in and out of the nucleus.',
                       'url': '131_hpa_subcell_task1_ref_HPA024023_nuclear_membrane.png',
                       'excludes': []},
                      {'id': 2,
                       'parentId': None,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Cytoplasm/CytoplasmHeader'),
                       'description': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Cytoplasm/CytoplasmDescription')},
                      {'id': 20,
                       'parentId': 2,
                       'name': 'Cytoplasm, aggresome and mitochondria',
                       'description': 'The cytoplasm is the encompasses the whole cell except for the nucleus. The aggresome and the mitochondria are two different organelles within the cytoplasm with very specific functions. They are also easy to recognize most of the time with their specific patterns.'},
                      {'id': 201,
                       'parentId': 20,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Cytoplasm/CytoplasmHeader'),
                       'description': 'The immunofluorescent staining of the cytoplasm encompasses the whole cell except for the nucleus. The staining can vary in intensity throughout the cell, and is often stronger close to the nucleus. The cytoplasm is a very heterogeneous mixture of different proteins.',
                       'descriptionIdentification': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Cytoplasm/CytoplasmDescriptionIdentification'),
                       'descriptionScientific': 'The cytoplasm is a very heterogenous mixture of different proteins.',
                       'url': '201_hpa_subcell_task1_ref_HPA002383_cytoplasm.png',
                       'excludes': []},
                      {'id': 202,
                       'parentId': 20,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Cytoplasm/AggresomeHeader'),
                       'description': 'The aggresome can be seen as a very dense, oval ball next to the nucleus. It overlaps with a hole in the microtubules. The aggresome contains proteins that are misfolded, which should be sent for destruction.',
                       'descriptionIdentification': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Cytoplasm/AggresomeDescriptionIdentification'),
                       'descriptionScientific': 'The aggresome contains proteins that are misfolded and will be sent for destruction.',
                       'url': '202_hpa_subcell_task1_ref_HPA053693_aggresome.png',
                       'excludes': []},
                      {'id': 203,
                       'parentId': 20,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Cytoplasm/MitochondriaHeader'),
                       'description': 'Mitochondrial stainings are most often easy to recognize as they have a long, thread like pattern, rather like spaghetti (sometimes long, and sometimes chopped up). They are spread throughout the cell, starting centrally, close to the nucleus and stretch all the way out to the edges of the cell. The mitochondria are responsible for supplying the cell with energy.',
                       'descriptionIdentification': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Cytoplasm/MitochondriaDescriptionIdentification'),
                       'descriptionScientific': 'The mitochondria are responsible for supplying the cell with energy by conversion of nutrients into ATP. It is also involved in signalling and regulating cell death.',
                       'url': '203_hpa_subcell_task1_ref_HPA001523_mitochondria.png',
                       'excludes': []},
                      {'id': 204,
                       'parentId': 20,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Cytoplasm/RodsAndRingsHeader'),
                       'description': 'Small and distinct rod and ring-like structures, usually only one or a few per cell.',
                       'descriptionIdentification': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Cytoplasm/RodsAndRingsDescriptionIdentification'),
                       'descriptionScientific': 'Rods and rings are, as the name suggests, rod and ring structures found in the cell. They are small but distinct and usually there are only one or a few of them. However, both shapes can occur in the same cell. Their function in the cell is yet unknown.',
                       'url': '204_rods_and_rings.png',
                       'excludes': [],
                       'difficulty': 3},
                      {'id': 21,
                       'parentId': 2,
                       'name': 'Cytoskeleton',
                       'description': "The cytoskeleton is a network of fibers with a multitude of functions. It gives the cell it's shape, is involved in cell motility, intracellular transport and cell division."},
                      {'id': 211,
                       'parentId': 21,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Cytoplasm/CytoskeletonIntermediateFilamentsHeader'),
                       'description': 'Intermediate filaments often have a tangled, rope-like structure that supports the cell structure. Those are often seen throughout the cell, whereas others, enclosing the nuclei, have a more condensed look. The role of intermediate filaments is to provide a mechanic support to the cell.',
                       'descriptionIdentification': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Cytoplasm/CytoskeletonIntermediateFilamentsDescriptionIdentification'),
                       'descriptionScientific': 'The role of intermediate filaments is to provide the cell with mechanical support. Some are in direct connection with the nuclear membrane, supporting it and anchoring the DNA to it.',
                       'url': '211_hpa_subcell_task1_ref_HPA040676_cytoskeleton_intermediate_filaments.png',
                       'excludes': []},
                      {'id': 212,
                       'parentId': 21,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Cytoplasm/CytoskeletonMicrotubuleEndsHeader'),
                       'description': "The microtubules grow by adding new fragments to the 'plus ends', which are the tips of the microtubules, furthest away from the nucleus. Sometimes only one end is stained and not the rest of the microtubule.",
                       'descriptionIdentification': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Cytoplasm/CytoskeletonMicrotubuleEndsDescriptionIdentification'),
                       'descriptionScientific': "The microtubules grow by adding new fragments to the 'plus ends', which are the tips of the microtubules, furthest away from the nucleus.",
                       'url': '212_hpa_subcell_task1_ref_HPA026678_cytoskeleton_microtubule_ends.png',
                       'excludes': []},
                      {'id': 213,
                       'parentId': 21,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Cytoplasm/CytoskeletonMicrotubulesHeader'),
                       'description': 'Staining of microtubules shows thin strands that stretch throughout the whole cell. It is almost always possible to detect the center from which they all originate, the centrosome, even though it need not be stained. The purpose of the microtubules is to act as a railway for transports around the cell.',
                       'descriptionIdentification': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Cytoplasm/CytoskeletonMicrotubulesDescriptionIdentification'),
                       'descriptionScientific': 'Staining of microtubules shows thin strands that stretch throughout the whole cell. It is almost always possible to detect the center from which they all originate, the centrosome, even though it need not be stained. The purpose of the microtubules is to act as a railway for transports around the cell, and separate duplicated DNA in cell division.',
                       'url': '213_hpa_subcell_task1_ref_HPA002647_cytoskeleton_microtubules.png',
                       'excludes': []},
                      {'id': 214,
                       'parentId': 21,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Cytoplasm/CytoskeletonActinFilamentsHeader'),
                       'description': 'Actin filaments are easy to recognize as they are often localized close to the plasma membrane, outlining the edges of the cell. They can usually be seen as long, very straight and parallel filaments and help hold up the membrane.',
                       'descriptionIdentification': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Cytoplasm/CytoskeletonActinFilamentsDescriptionIdentification'),
                       'descriptionScientific': 'Actin filaments are easy to recognize as they are often localized close to the plasma membrane, outlining the edges of the cell. They can usually be seen as long, very straight and parallel filaments and help the membrane keeping its shape. It is also involved in cell motility.',
                       'url': '214_hpa_subcell_task1_ref_HPA043746_cytoskeleton_actin_filaments.png',
                       'excludes': []},
                      {'id': 215,
                       'parentId': 21,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Cytoplasm/CytoskeletonCytokineticBridgeHeader'),
                       'description': 'The cytokinetic bridge is a small structure present during the last stage of cell division, and can only be seen at the tip between two cells that have almost been separated and moved apart. It acts as a scissor, which cuts the bond between the two cells.',
                       'descriptionIdentification': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Cytoplasm/CytoskeletonCytokineticBridgeDescriptionIdentification'),
                       'descriptionScientific': 'The cytokinetic bridge is a small structure present during the last stage of cell division, and can only be seen at the tip between two dividing cells that have almost been separated and moved apart. It acts as a scissor, which cuts the bond between the two cells.',
                       'url': '215_hpa_subcell_task1_ref_HPA028258_cytoskeleton_cytokinetic_bridge.png',
                       'excludes': []},
                      {'id': 22,
                       'parentId': 2,
                       'name': 'Center of microtubules',
                       'description': 'The microtubule organizing center and centrosome is found at the center of the microtubules.'},
                      {'id': 221,
                       'parentId': 22,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Cytoplasm/MicrotubuleOrganizingCenterHeader'),
                       'description': 'The centrosome/MTOC always overlaps with the center of the microtubules, making it easy to find next to the nucleus. Stainings of single or double spots at the origin of microtubules are annotated as centrosome whereas larger structures stained at that location are annotated as MTOC (microtubule organizing center). The centrosome helps the cell to divide.',
                       'descriptionIdentification': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Cytoplasm/MicrotubuleOrganizingCenterDescriptionIdentification'),
                       'descriptionScientific': 'The MTOC (microtubule organizing center) always overlaps with the center of the microtubules, making it easy to find next to the nucleus. Staining of single or double spots at the origin of microtubules are annotated as centrosomes whereas larger structures centered at that location are annotated as MTOC. The centrosome helps the cell to divide.',
                       'url': '221_hpa_subcell_task1_ref_HPA050499_microtubule_organizing_center.png',
                       'excludes': [222]},
                      {'id': 222,
                       'parentId': 22,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Cytoplasm/CentrosomeHeader'),
                       'description': 'The centrosome/MTOC always overlaps with the center of the microtubules, making it easy to find next to the nucleus. Stainings of single or double spots at the origin of microtubules are annotated as centrosome whereas larger structures stained at that location are annotated as MTOC (microtubule organizing center). The centrosome helps the cell to divide.',
                       'descriptionIdentification': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Cytoplasm/CentrosomeDescriptionIdentification'),
                       'descriptionScientific': 'The centrosome always overlaps with the center of the microtubules, making it easy to find next to the nucleus. Staining of single or double spots at the origin of microtubules are annotated as centrosomes whereas larger structures centered at that location are annotated as MTOC (microtubule organizing center). The centrosome helps the cell to divide.',
                       'url': '222_hpa_subcell_task1_ref_HPA043212_centrosome.png',
                       'excludes': [221]},
                      {'id': 23,
                       'parentId': 2,
                       'name': 'Secretory organelles',
                       'description': 'These organells form, together with the plasma membrane, the secretory pathway in the cell. These steps forms the basis for secretion, which is a way for the cell to move proteins out of itself'},
                      {'id': 231,
                       'parentId': 23,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Cytoplasm/EndoplasmicReticulumHeader'),
                       'description': "The endoplasmic reticulum is a network stretching throughout the cytoplasm. It's structure can be likened to a spider web and it's a hub where proteins are stored and sometimes modified before sent along to the Golgi apparatus.",
                       'descriptionIdentification': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Cytoplasm/EndoplasmicReticulumDescriptionIdentification'),
                       'descriptionScientific': "The endoplasmic reticulum is a symmetrical network stretching throughout the cytoplasm. Its structure can be likened to a spider's web and it's a hub where proteins are stored and sometimes modified before sent along to the Golgi apparatus for further modification.",
                       'url': '231_hpa_subcell_task1_ref_HPA012542_endoplasmic_reticulum.png',
                       'excludes': []},
                      {'id': 232,
                       'parentId': 23,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Cytoplasm/TheGolgiApparatusHeader'),
                       'description': 'The Golgi apparatus is located next to the nucleus, sometimes growing around it. It often looks like collection of small particles. The Golgi handles incoming proteins from the endoplasmic reticulum, modifies them and then sends them off to their final destinations within the cell.',
                       'descriptionIdentification': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Cytoplasm/TheGolgiApparatusDescriptionIdentification'),
                       'descriptionScientific': 'The Golgi handles incoming proteins from the endoplasmic reticulum, modifies them and then sends them off to their final destinations within the cell.',
                       'url': '232_hpa_subcell_task1_ref_HPA008395_the_Golgi_appratus.png',
                       'excludes': []},
                      {'id': 233,
                       'parentId': 23,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Cytoplasm/VesiclesHeader'),
                       'description': 'Vesicles can be seen as small, bright dots that are uniform in size and shape. They are either distributed evenly throughout the cell, or clustering next to the nucleus. Vesicles are responsible for moving things (cargo) around in the cell.',
                       'descriptionIdentification': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Cytoplasm/VesiclesDescriptionIdentification'),
                       'descriptionScientific': "Several different types of vesicles exist, some are responsible for moving cargo in the cell, others are degrading proteins and some work with transporting and subsequently releasing signal substances from the cell's membrane.",
                       'url': '233_hpa_subcell_task1_ref_HPA002078_vesicles.png',
                       'excludes': []},
                      {'id': 3,
                       'parentId': None,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Periphery/PeripheryHeader'),
                       'description': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Periphery/PeripheryDescription')},
                      {'id': 30,
                       'parentId': 3,
                       'name': 'Periphery',
                       'description': 'These structures are part of the outer edges of the cell.'},
                      {'id': 301,
                       'parentId': 30,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Periphery/CellJunctionsHeader'),
                       'description': 'Staining of cell junctions can only be observed when the cells are in contact. The staining is very specific, and is only seen at the actual site of cell-cell connections. Cell junctions are important for cell-cell communication.',
                       'descriptionIdentification': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Periphery/CellJunctionsDescriptionIdentification'),
                       'descriptionScientific': 'Staining of cell junctions can only be observed when the cells are in contact. The staining is very specific, and is only seen at the actual site of cell-cell connections. Cell junctions are important for cell-cell communication.',
                       'url': '301_hpa_subcell_task1_ref_HPA036958_cell_junctions.png',
                       'excludes': []},
                      {'id': 302,
                       'parentId': 30,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Periphery/FocalAdhesionsHeader'),
                       'description': 'Focal adhesions are localized just outside the cell membrane and can thus be found either just under the cell or at the edge of the cell membrane, where the cell is attached to the surface. They are the feet of the cell, and is what the cell uses to move across a surface in response to signals.',
                       'descriptionIdentification': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Periphery/FocalAdhesionsDescriptionIdentification'),
                       'descriptionScientific': 'Focal adhesions keep the cells attached to the surface by acting as linkers between actin filaments and the surface. They are used by the cell to move across a surface in response to signals.',
                       'url': '302_hpa_subcell_task1_ref_HPA055338_focal_adhesions.png',
                       'excludes': []},
                      {'id': 303,
                       'parentId': 30,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Periphery/PlasmaMembraneHeader'),
                       'description': 'The cell membrane - or the plasma membrane - encloses the cell and acts as a border towards the environment. Staining of the cell membrane can appear differently, sometimes the staining only appear as a rim around the cell, sometimes protrusions are extending from it and sometimes it may appear as a uniform and very flat staining across the entire cell.',
                       'descriptionIdentification': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Periphery/PlasmaMembraneDescriptionIdentification'),
                       'descriptionScientific': 'The cell membrane - or the plasma membrane - encloses the cell and acts as a border towards the environment. It regulates transports in and out of the cell of substances such as signal molecules and nutrients.',
                       'url': '303_hpa_subcell_task1_ref_HPA029159_plasma_membrane.png',
                       'excludes': []},
                      {'id': 8,
                       'parentId': None,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Misc/MiscHeader'),
                       'description': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Misc/MiscDescription')},
                      {'id': 80,
                       'parentId': 8,
                       'name': 'Miscellaneous',
                       'description': 'Miscellaneous protein patterns'},
                      {'id': 801,
                       'parentId': 80,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Misc/CellToCellVariationsHeader'),
                       'description': 'Either varying intensity of the same location in different cells or differences in location between cells.',
                       'descriptionIdentification': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/Misc/CellToCellVariationsDescriptionIdentification'),
                       'descriptionScientific': 'As the cell is growing and dividing it undergoes different life cycles. During those cycles the protein content and distribution can vary. Proteins can move between different locations, or they can be more or less expressed. This can be observed as differences in locations between cells, or in varying intensity of the same location in different cells.',
                       'excludes': [],
                       'url': '801_cell_to_cell_variations.png'},
                      {'id': 9,
                       'parentId': None,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/NotIdentifiable/NotIdentifiableHeader'),
                       'description': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/NotIdentifiable/NotIdentifiableDescription')},
                      {'id': 90,
                       'parentId': 9,
                       'name': 'Not identifiable',
                       'description': 'Negative or unspecific staining'},
                      {'id': 901,
                       'parentId': 90,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/NotIdentifiable/NegativeHeader'),
                       'description': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/NotIdentifiable/NegativeDescription'),
                       'url': '901_hpa_subcell_task1_ref_HPA055108_negative.png',
                       'excludes': '*'},
                      {'id': 902,
                       'parentId': 90,
                       'name': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/NotIdentifiable/UnspecificHeader'),
                       'description': localization.GetByLabel('UI/ProjectDiscovery/Subcellular/CellCategories/NotIdentifiable/UnspecificDescription'),
                       'url': '902_hpa_subcell_task1_ref_HPA034636_unspecific.png',
                       'excludes': '*'}]},
 'infoSchema': {'type': 'object',
                'properties': {'baseUrl': {'description': 'The base url to add to the class urls',
                                           'type': 'string'},
                               'classes': {'type': 'array',
                                           'items': {'type': 'object',
                                                     'properties': {'id': {'description': 'The id of the class',
                                                                           'type': 'string'},
                                                                    'parentId': {'description': 'The id of the containing class',
                                                                                 'type': 'string'},
                                                                    'name': {'description': 'The name of the class',
                                                                             'type': 'string'},
                                                                    'description': {'description': 'The description of the class',
                                                                                    'type': 'string'},
                                                                    'url': {'description': 'The URL of the reference image',
                                                                            'type': 'string'},
                                                                    'excludes': {'oneOf': [{'type': 'array',
                                                                                            'items': {'description': "The id of the class that can't be selected in case of the class is selected.",
                                                                                                      'type': 'integer'}}, {'description': "The string '*' marks that all other classes are excluded",
                                                                                            'type': 'string'}]}}}}}}}